{Utilidades para Turbo Pascal - Hector Mauricio Rodriguez Segura}

Unit TPUtils;

interface
Uses
   Crt;

Const

   Null = #0;
   Esc = #27;

   F1 = ';';
   F2 = '<';
   F3 = '=';
   F4 = '>';
   F5 = '?';
   F6 = '@';
   F7 = 'A';
   F8 = 'B';
   F9 = 'C';
   F10 = 'D';
   CtrlF3 = #96;
   AltX = #45;

   Izq = 'K';
   Der = 'M';
   Arr = 'H';
   Av = 'P';

   E1 = #201;
   E2 = #187;
   E3 = #200;
   E4 = #188;

   Hor = #205;
   Ver = #186;


Var
  CharAlfaNum: Boolean;

Function IntToStr(I: Integer): String;
Function StrToIntDef(S: String; Def: Integer): Integer;
Procedure Sound(Hz, D: Integer);
Function StringOfChar(AChar: Char; Count: Byte): String;
Function ReadChar: Char;
Procedure Centrar(Txt: String; L: Byte);
Procedure SetColors(BG, FG: Byte);
Procedure WriteXY(X, Y: Byte; Txt: String);
Function ReadMax(Max: Byte): String;
Function ShowMsg(Msg: String; LeerTecla: Boolean; H, D: Word): Char;
implementation

Function ShowMsg(Msg: String; LeerTecla: Boolean; H, D: Word): Char;
Var
  S, S2: String[70];
  L: Integer;
  Atr: Integer;
Begin
  Atr := TextAttr;
  SetColors(Blue, White);
  S := Msg;
  L := Length(S) + 4;
  Centrar(E1 + StringOfChar(Hor, L) + E2, 10);
  Centrar(Ver + StringOfChar(' ', L) + Ver, 11);
  Centrar(Ver + '  ' + S + '  ' + Ver, 12);
  Centrar(Ver + StringOfChar(' ', L) + Ver, 13);
  Centrar(E3 + StringOfChar(Hor, L) + E4, 14);
  Sound(H, D);
  if LeerTecla then ShowMsg := ReadKey;
  TextAttr := Atr;
end;

Function IntToStr(I: Integer): String;
Var
  S: String;
Begin
   Str(I, S);
   IntToStr := S;
end;

Function StrToIntDef(S: String; Def: Integer): Integer;
Var
  R, E: Integer;
Begin
  Val(S, R, E);
  if E > 0 then
    R := Def;
  StrToIntDef := R;
end;

Procedure Sound(Hz, D: Integer);
Begin
   Crt.Sound(Hz);
   Delay(D);
   NoSound;
end;

Function StringOfChar(AChar: Char; Count: Byte): String;
Var
  C: Integer;
  S: String;
Begin
  S := '';
  For C := 1 to Count do
    S := S + AChar;
  StringOfChar := S;
end;


Function ReadChar: Char;
Var
  Ch: Char;
Begin
  CharAlfaNum := True;
  Ch := ReadKey;
  if Ch = Null then
  Begin
    Ch := ReadKey;
    CharAlfaNum := False;
  end;
  ReadChar := Ch;
end;

Procedure Centrar(Txt: String; L: Byte);
Begin
  GotoXY((80 - Length(Txt)) div 2, L);
  Write(Txt);
end;

Procedure SetColors(BG, FG: Byte);
Begin
   TextBackGround(BG);
   TextColor(FG);
end;

Procedure WriteXY(X, Y: Byte; Txt: String);
Begin
  GotoXY(X, Y); Write(Txt);
end;

Function ReadMax(Max: Byte): String;
Var
  Ch: Char;
  C, I: Integer;
  S: String;
  X, Y: Byte;
Begin
   S := '';
   C := 0;
   I := 0;
   X := WhereX;
   Y := WhereY;
   Repeat
     Ch := ReadChar;
     if CharAlfanum then
     Begin
       if (Ch = #8) then
       Begin
         if I > 0 then
         Begin
           Delete(S, I, 1);
           Dec(C);
           Dec(I);
         end;
       end else
       if C < Max then
       Begin
         Inc(C);
         Inc(I);
         if Ch <> #13 then Insert(Ch, S, I);
       end else
       Sound(1500, 2500);
     end else
     Case Ch of
       Izq: if I > 0 then
            Begin
              Dec(I);
              GotoXY(X + I, Y);
            end;
       Der: if I < C then
            Begin
              Inc(I);
              GotoXY(X + I, Y);
            end;

       'S': if C > 0 then
            Begin
              Delete(S, I + 1, 1);
              Dec(C);
            end;
       #71: I := 0;
       #79: I := Length(S);
     end;
     WriteXY(X, Y, StringOfChar(' ', Max));
     WriteXY(X, Y, S);
     GotoXY(X + I, Y);
   Until Ch = #13;
   ReadMax := S;
end;


Begin
  { NADA }
end.